﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace Prohlížeč
{
    public enum ZpusobZobrazeni
    {
        normalni,
        zoom,

    }

    public partial class Form1 : Form
    {
        public string aktualniCesta = "";
        public string cestaPrvniho = "";
        public string cestaPosledniho = "";
        public string cestaPredesleho = "";
        public string cestaDalsiho = "";

        public Point poziceObrazku = Point.Empty;
        public float imageZoom = 1f;
        public Size puvodniVelikost = Size.Empty;
        public bool flipVertical = false;
        public bool flipHorizontal = false;
        public bool balckWhite = false;

        public Form1(string cesta)
        {
            aktualniCesta = cesta;
            InitializeComponent();

            RozhodniCoDal();
        }

        private void RozhodniCoDal()
        {
            if (aktualniCesta.EndsWith(".jpg") || aktualniCesta.EndsWith(".jpg"))
            {
            }
            else
            {
                // Zobrazí formulář pro otevření obrázku
                OpenFileDialog fd = new OpenFileDialog();
                fd.FileName = aktualniCesta;
                fd.Filter = "Jpg files|*.jpg|Jpeg files|*.jpeg";
                DialogResult r = fd.ShowDialog();
                if (r.ToString() == "Cancel")
                {
                    this.Dispose();
                }

                aktualniCesta = fd.FileName;
            }

            // Pokusí se otevřít obrázek
            try
            {
                // Otevře obrázek ze souboru a nastaví jeho pozici
                pictureBox1.Image = Image.FromFile(aktualniCesta);
                pictureBox1.DoubleClick += new EventHandler(pictureBox1_DoubleClick);

                // Připraví vykreslování a změnu obrázku
                pictureBox1.Size = new Size(pictureBox1.Image.Width, pictureBox1.Image.Height);                
                pictureBox1.Paint += new PaintEventHandler(pictureBox1_Paint);

                // Nastavé výchozí informace
                puvodniVelikost = pictureBox1.Size;
                poziceObrazku = Point.Empty;
                imageZoom = 1f;

                // nastaví optimální velikost okna
                this.Width = pictureBox1.Image.Width;
                this.Height = pictureBox1.Image.Height + 300;

                // Získá první, poslední, předchozí a následující obrázek
                string[] str = Directory.GetFiles(aktualniCesta.Substring(0, aktualniCesta.LastIndexOf('\\')) + "\\");
                List<string> fileNames = new List<string>();
                int indexAktualniho = 1;

                for (int i = 0; i < str.Length; i++)
                {
                    if (str[i].EndsWith(".jpg") || str[i].EndsWith(".jpeg"))
                    {
                        fileNames.Add(str[i]);
                    }
                    if (str[i] == aktualniCesta)
                    {
                        indexAktualniho = i - 1;
                    }
                }

                /* připraví náhledy */
                if (indexAktualniho != 0)
                {
                    prvni.Visible = true;
                    cestaPrvniho = fileNames[0];
                    prvni.Name = cestaPrvniho;
                    prvni.Image = Image.FromFile(fileNames[0]);
                    prvni.Location = new Point(20, pictureBox1.Image.Height + 20);
                    prvni.Size = new Size(133, 100);
                    prvni.Click += new EventHandler(nahled_Click);
                    prvni.Paint += new PaintEventHandler(nahled_Paint);
                }
                else
                {
                    prvni.Visible = false;
                    predchozi.Name = "";
                }

                if (indexAktualniho != 0)
                {
                    predchozi.Visible = true;
                    cestaPredesleho = fileNames[indexAktualniho - 1];
                    predchozi.Name = cestaPredesleho;
                    predchozi.Image = Image.FromFile(fileNames[indexAktualniho - 1]);
                    predchozi.Location = new Point(133 + 20, pictureBox1.Image.Height + 20);
                    predchozi.Size = new Size(133, 100);
                    predchozi.Click += new EventHandler(nahled_Click);
                    predchozi.Paint += new PaintEventHandler(nahled_Paint);
                }
                else
                {
                    predchozi.Visible = false;
                    predchozi.Name = "";
                }

                if (indexAktualniho != fileNames.Count - 1)
                {
                    dalsi.Visible = true;
                    cestaDalsiho = fileNames[indexAktualniho + 1];
                    dalsi.Name = cestaDalsiho;
                    dalsi.Image = Image.FromFile(fileNames[indexAktualniho + 1]);
                    dalsi.Location = new Point(286, pictureBox1.Image.Height + 20);
                    dalsi.Size = new Size(133, 100);
                    dalsi.Click += new EventHandler(nahled_Click);
                    dalsi.Paint += new PaintEventHandler(nahled_Paint);
                }
                else
                {
                    dalsi.Visible = false;
                    dalsi.Name = "";
                }

                if (indexAktualniho != (fileNames.Count - 1))
                {
                    posledni.Visible = true;
                    cestaPosledniho = fileNames[fileNames.Count - 1];
                    posledni.Name = cestaPosledniho;
                    posledni.Image = Image.FromFile(fileNames[fileNames.Count - 1]);
                    posledni.Location = new Point(400 + 20, pictureBox1.Image.Height + 20);
                    posledni.Size = new Size(133, 100);
                    posledni.Click += new EventHandler(nahled_Click);
                    posledni.Paint += new PaintEventHandler(nahled_Paint);
                }
                else
                {
                    posledni.Visible = false;
                    posledni.Name = "";
                }

                Invalidate();
            }
            // Pokud se to nepovede, ukončí aplikaci - uživatel pravděpodobně zmáčkl storno
            catch (Exception e)
            {
                MessageBox.Show("Stala se chyba: " + e.Message);
            }
        }

        void nahled_Paint(object sender, PaintEventArgs e)
        {
            PictureBox odesilatel = (PictureBox)sender;
            float ratio = odesilatel.Image.Width / odesilatel.Image.Height;
            
            e.Graphics.DrawImage(odesilatel.Image, (float)poziceObrazku.X, (float)poziceObrazku.Y, 100f, 100f * ratio);
        }

        void pictureBox1_Paint(object sender, PaintEventArgs e)
        {
            PictureBox odesilatel = (PictureBox) sender;
            e.Graphics.DrawImage(odesilatel.Image, (float)poziceObrazku.X, (float)poziceObrazku.Y, (float)odesilatel.Image.Width * imageZoom, (float)odesilatel.Image.Height * imageZoom);
        }

        void nahled_Click(object sender, EventArgs e)
        {
            PictureBox odesilatel = (PictureBox)sender;
            aktualniCesta = odesilatel.Name;
            odesilatel.Name = "";
            cestaPrvniho = "";
            cestaPredesleho = "";
            cestaPosledniho = "";
            RozhodniCoDal();
        }

        void pictureBox1_DoubleClick(object sender, EventArgs e)
        {
            // Po dvojkliku na hlavní obrázek se otevře nabídka pro vybrání nového obrázku
            this.aktualniCesta = aktualniCesta.Substring(0, aktualniCesta.LastIndexOf('\\')); //+ "\\";
            RozhodniCoDal();
        }

        protected override void OnPaint(PaintEventArgs e)
        {
            e.Graphics.Clear(Color.White);
            base.OnPaint(e);                
        }

        protected override void OnKeyDown(KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Home)
            {
                aktualniCesta = cestaPrvniho;
                cestaPrvniho = "";
                cestaPredesleho = "";
                cestaPosledniho = "";
                RozhodniCoDal();
            }
            else if (e.KeyCode == Keys.End)
            {
                aktualniCesta = cestaPosledniho;
                cestaPrvniho = "";
                cestaPredesleho = "";
                cestaPosledniho = "";
                RozhodniCoDal();
            }
            else if (e.KeyCode == Keys.PageUp)
            {
                aktualniCesta = cestaPredesleho;
                cestaPrvniho = "";
                cestaPredesleho = "";
                cestaPosledniho = "";
                RozhodniCoDal();
            }
            else if (e.KeyCode == Keys.PageDown)
            {
                aktualniCesta = cestaDalsiho;
                cestaPrvniho = "";
                cestaPredesleho = "";
                cestaPosledniho = "";
                RozhodniCoDal();
            }

            if (e.KeyCode == Keys.Up)
            {
                poziceObrazku.Y -= 5;
            }
            else if (e.KeyCode == Keys.Down)
            {
                poziceObrazku.Y += 5;
            }

            if (e.KeyCode == Keys.Left)
            {
                poziceObrazku.X -= 5;
            }
            else if (e.KeyCode == Keys.Right)
            {
                poziceObrazku.X += 5;
            }

            if (e.KeyCode == Keys.Escape)
                this.Dispose();


            base.OnKeyDown(e);
        }


        protected override void OnKeyPress(KeyPressEventArgs e)
        {
            if (e.KeyChar == '+')
            {
                imageZoom += 0.1f;
                if (imageZoom > 3f)
                {
                    imageZoom = 3f;
                }
            }
            else if (e.KeyChar == '-')
            {
                imageZoom -= 0.1f;
                if (imageZoom < 0.1f)
                {
                    imageZoom = 0.1f;
                }
            }
            else if (e.KeyChar == '*')
            {
                imageZoom = 1f;
            }
            else if (e.KeyChar == '/')
            {
                if (pictureBox1.Size.Width > pictureBox1.Size.Height)
                {
                    imageZoom = ClientSize.Width / pictureBox1.Image.Width;
                }
                else
                {
                    imageZoom = ClientSize.Width / pictureBox1.Image.Width;
                }
            }
            else if (e.KeyChar == 'h' || e.KeyChar == 'H')
            {
                pictureBox1.Image.RotateFlip(RotateFlipType.RotateNoneFlipX);
            }
            else if (e.KeyChar == 'v' || e.KeyChar == 'V')
            {
                pictureBox1.Image.RotateFlip(RotateFlipType.RotateNoneFlipY);
            }
            else if (e.KeyChar == 'l' || e.KeyChar == 'L')
            {
                pictureBox1.Image.RotateFlip(RotateFlipType.Rotate270FlipNone);
                pictureBox1.Height = pictureBox1.Width;
            }
            else if (e.KeyChar == 'r' || e.KeyChar == 'R')
            {
                pictureBox1.Image.RotateFlip(RotateFlipType.Rotate90FlipNone);
                pictureBox1.Height = pictureBox1.Width;
            }
            else
            {
            }


            Invalidate();
            pictureBox1.Invalidate();

            base.OnKeyPress(e);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            imageZoom += 0.1f;
            if (imageZoom > 3f)
            {
                imageZoom = 3f;
            }

            Invalidate();
            pictureBox1.Invalidate();
        }

        private void button2_KeyPress(object sender, KeyPressEventArgs e)
        {
            OnKeyPress(e);
        }

        private void button2_KeyDown(object sender, KeyEventArgs e)
        {
            OnKeyDown(e);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            imageZoom -= 0.1f;
            if (imageZoom < 0.1f)
            {
                imageZoom = 0.1f;
            }

            Invalidate();
            pictureBox1.Invalidate();
        }

        private void button1_KeyDown(object sender, KeyEventArgs e)
        {
            OnKeyDown(e);
        }

        private void button1_KeyPress(object sender, KeyPressEventArgs e)
        {
            OnKeyPress(e);
        }
        
    }
}
